/*
 * @(#)ConnectionFailedException.java	1.0 2001/03/12
 *
 * Copyright (C) 2001 by Maru Newby ekko@users.sourceforge.net
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * To contact the author, email ekko@users.sourceforge.net.
 */


package net.sourceforge.journeyftp.adapter;


/**
 * Indicates that an adapter is not connected to a server.
 *
 * @author  Maru Newby
 * @version 1.0, 2001/03/12
 */
public class ConnectionFailedException extends OperationFailedException
{


    /**
     * Constructs an exception with no specified detail message.
     */
    public ConnectionFailedException()
    {
        super("", null, "");
    }


    /**
     * Constructs an exception with the specified detail message.
     *
     * @param s             the detail message
     */
    public ConnectionFailedException(String s)
    {
        super(s, null, "");
    }


    /**
     * Constructs an exception with the specified detail message and exception.
     *
     * @param s             the detail message
     * @parma ex            the root exception
     */
    public ConnectionFailedException(String s, Exception ex)
    {
        this(s, ex, "");

    }


    /**
     * Constructs an exception with the specified detail message, exception,
     * and detailed error.
     *
     * @param s             the detail message
     * @parma ex            the root exception
     * @param error         the detailed error
     */
    public ConnectionFailedException(String s, Exception ex, String error)
    {
        super(s, ex, error);
    }


} // end: ConnectionFailedException

