/*
 * @(#)TelnetFileTransferConnection.java	1.0 2001/03/21
 *
 * Copyright (C) 2001 by Maru Newby
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * To contact the author, email ekko@users.sourceforge.net.
 */


package net.sourceforge.journeyftp.adapter.jta;


// Adapter imports
import net.sourceforge.journeyftp.adapter.FileTransferConnection;


/**
 * Wrapper for any connection-related data needed to perform a file transfer.
 *
 * @author  Maru Newby
 * @version 1.0, 2001/03/21
 */
public class TelnetFileTransferConnection implements FileTransferConnection
{
    // Instance variables
    private TelnetClient _client = null;


    /**
     * Constructor taking the telnet client object that will be used for
     * file transfers.
     */
    public TelnetFileTransferConnection(TelnetClient client)
    {
        _client = client;
    }


    /**
     * Accessor for the ftp client.
     *
     * @return              the ftp client object
     */
    public TelnetClient getTelnetClient()
    {
        return (_client);

    } // end: getFtpClient


} // end: TelnetFileTransferConnection
