/* ********************************************************* */
/* ================== conInfoList.java ====================== */
/* ********************************************************* */

/*  This class is used to save at most ten most recent connections */
/*  using with 'read' and 'write' at the backend */

package net.sourceforge.journeyftp.backend;

import java.io.*;
import java.util.*;

import net.sourceforge.journeyftp.adapter.*;
import net.sourceforge.journeyftp.adapter.fooftp.*;

//ConInfoList
public class ConInfoList implements Serializable {

   private ConnectionInfo con_info = null;
   private LinkedList con_list = new LinkedList();
   public static final int SIZE = 10;
  // List list = Collections.synchronizedList(new LinkedList(q_list));

  /* empty constructor */
  public ConInfoList ()
  {

  }


  /* constructor with ConnectionInfo object */
  public ConInfoList (ConnectionInfo c_info)
  {
     con_info = c_info;
  }


  /* This is the most important method for this class */
  /* It adds connection information to the end of this list */
  public void addOn(ConnectionInfo con_info)
  {
     ConnectionInfo temp;
     int at = con_list.indexOf(con_info);
     if (at == -1)
     {
	     if (isEmpty())
		con_list.addFirst(con_info);

	     else if (isFull()) {
	        con_list.removeLast();
	        con_list.addFirst(con_info);
	     }

	     else
	     {
	        con_list.addFirst(con_info);
	     }
   }
   else
   {
   	temp = (ConnectionInfo)con_list.remove(at);
   	con_list.addFirst(temp);
   }

 }// addOn

  /* clear up the queue */
  public void clear()
  {
     if (con_list.size() > 0)
        con_list.clear();
  } // clear



/* delete an element from the list */
   public void delete (ConnectionInfo con_info)
   {
      con_list.remove (con_info);
   } // delete



   /* Test if the list is empty  */
   public boolean isEmpty ()
   {
     if (con_list.size() == 0)
        return true;

     else
        return false;
   }  //isEmpty



   /* Test if the list is full  */
   public boolean isFull ()
  {
     if (con_list.size() >= SIZE)
        return true;

     else
        return false;
   }  //isFull


/* display all elements in the queue */   //It may not be needed
   public ConnectionInfo[] display()
   {  
      ConnectionInfo[] this_info = new ConnectionInfo[con_list.size()]; 
      for (int i = 0; i < con_list.size(); i++) {
	  this_info[i] = (ConnectionInfo) con_list.get(i);
	}
	
	return this_info;
	
   } //display

   public String[] displayNames()
   {
      String[] this_info = new String[con_list.size()];
      for (int i = 0; i < con_list.size(); i++) {
	  this_info[i] = ((ConnectionInfo) con_list.get(i)).getHost();
	}
	
	return this_info;
	
   } //display

   public void toDisk()
   {
   	try
   	{
	   	File outFile = new File ("thelist.dat");
	   	FileOutputStream fout= new FileOutputStream(outFile);
   		ObjectOutputStream oout = new ObjectOutputStream(fout);
   		oout.writeObject(this);
   		fout.close();   	
   	}
   	catch (IOException e)
   	{
   	
   	}
   }

   public ConInfoList fromDisk()
   {
   	ConInfoList theList;
   	File inFile = new File ("thelist.dat");
   	
   	try
   	{
	   	if (!inFile.exists())
   		{
   			System.out.println("I don't exists");
   			return null;		
   		}
   		else
   		{
   			FileInputStream fin= new FileInputStream(inFile);
   			ObjectInputStream oin = new ObjectInputStream(fin);
   			theList = (ConInfoList) oin.readObject();
   			fin.close();
   		}
   		return theList;
   	}
   	catch (ClassNotFoundException e)
   	{
   		System.out.println("class not found" + e.getMessage());
   		return null;
   	}
   	
   	catch (IOException e)
   	{
   	 	System.out.println("IO Error" + e.getMessage());
   	 	return null;
   	}
   }


} //ConInfoList



