/* *********************************************************************** */
/* ============================= QueueFtp.java =========================== */
/* *********************************************************************** */


/* This class deals with Queued files: get and put files */

package net.sourceforge.journeyftp.backend;


import java.io.*;
import java.text.SimpleDateFormat;
import java.text.DateFormat;
import java.util.*;

import net.sourceforge.journeyftp.gui.MessageManager;
import net.sourceforge.journeyftp.gui.TransferObserver;
import net.sourceforge.journeyftp.adapter.*;
import net.sourceforge.journeyftp.adapter.fooftp.*;

// QueueFtp
public class QueueFtp
{
  private QueuedFile q_files= null;
  private FTPBackend back;
  private TransferObserver theDyer;
  private ConnectionInfo oldConnection;

  /* empty constructor */
  public QueueFtp (TransferObserver thingy, MessageManager middleMan, FTPBackend theback )
  {
  	theDyer = thingy;
  	back = theback;

  	if (theback.isConnected())
  	{
  		theback.doDisconnect();
	 	oldConnection = theback.getConnectionInfo();
  	}
  	else
  	{
  		oldConnection = null;
  	}

  }

 /* Start to transfer Queued files */
 /* It may be called by gui to get or put files */
  public void startQueue (QueuedFile qfile)
  {
     QueueInfo q_info = null;

     while (!qfile.isEmpty())
     {
        q_info = (QueueInfo) qfile.retrieve();

        ConnectionInfo host_info = q_info.getConnectionInfo();

        back.doConnect(host_info);

        VirtualFile[] q_vfile = new VirtualFile[1];
        q_vfile[0] = q_info.getVirtualFile();

        if (q_info.getRequest().equals("get"))
        {
              back.getFile(q_vfile, theDyer);
        }

         else if (q_info.getRequest().equals("put"))
         {
                 back.putFile(q_vfile, theDyer);
         }

         qfile.remove();
         back.doDisconnect();
      }  // while

	if (oldConnection != null)
		back.doConnect(oldConnection);
  } // startQueue



 /* Stop transferring Queued files */
 /* It may be called by gui to stop getting or putting files */
  public void stopQueue (QueuedFile qfile)
  {

  System.out.println("STOP QUEUEDFILE TRANSFER");

  } //stopQueue



  /* Resume to transfer Queued files */
 /* It may be called by gui to continue getting or putting files */
  public void resumeQueue (QueuedFile qfile)
  {

   System.out.println("RESUME QUEUEDFILE TRANSFER");

  } //resumeQueue


  } //QueueFtp
