/* ********************************************************* */
/* ================== QueuedFile.java ====================== */
/* ********************************************************* */


/*  This class deals with queued file operations during download or upload*/


package net.sourceforge.journeyftp.backend;

import java.io.*;
import java.util.*;
import java.text.SimpleDateFormat;
import java.text.DateFormat;

import net.sourceforge.journeyftp.adapter.*;
import net.sourceforge.journeyftp.adapter.fooftp.*;


//QueuedFiles
public class QueuedFile {

   private QueueInfo q_info = null;
   private LinkedList q_list = new LinkedList();
  // List list = Collections.synchronizedList(new LinkedList(q_list));

  /* empty constructor */
  public QueuedFile ()
  {
  }


  /* constructor with Virtualfile and ConnectionInfo objects */
  public QueuedFile (QueueInfo info) {
     q_info = info;
     }


  /* append the specified element to the end of this queue */
  public void append(QueueInfo q_info)
  {
     if (q_list.size() == 0)
        q_list.addFirst(q_info);

     else
        q_list.addLast(q_info);
   }  // append


  /* clear up the queue */
  public void clear()
  {
     if (q_list.size() > 0)
        q_list.clear();
  } // clear


 /* remove the first element and return the removed object */
   public Object remove ()
  {
     if (q_list.size() > 0) {
        return q_list.removeFirst();
	}

     else
        return null;
	
   }  // remove


/* delete an element from the queue */
   public void delete (QueueInfo q_info)
   {
      q_list.remove (q_info);
   } // delete


 /* move up to the top of the queue */
   public void moveToTop (QueueInfo q_info)
  {
     int i = q_list.indexOf(q_info);

     if (i > 0) {
        q_list.addFirst(q_info);
        q_list.remove(i + 1);
        }
   } // moveToTop



/* move up to the bottom of the queue */
   public void moveToBottom (QueueInfo q_info)
  {
     int i = q_list.indexOf(q_info);

     if (i < q_list.size() - 1) {
        q_list.addLast(q_info);
        q_list.remove(i);
        }

   } // moveToBottom



/* move up one position in the queue */
   public void moveUp (QueueInfo q_info)
  {
     int i = q_list.indexOf(q_info);

     if (i > 0) {
        q_list.add(i - 1, q_info);
        q_list.remove(i + 1);
        }
   }  // moveUp



/* move down one position in the queue */
   public void moveDown (QueueInfo q_info)
  {
     int i = q_list.indexOf(q_info);

     if (i < q_list.size() - 1) {
        q_list.add(i + 2, q_info);
        q_list.remove(i);
        }
   } //moveDown



   /* move down one position in the queue */
   public boolean isEmpty ()
  {
     if (q_list.size() == 0)
        return true;

     else
        return false;
   }  //isEmpty



   /* move down one position in the queue */
   public Object retrieve ()
  {
     if (q_list.size() > 0)
        return q_list.getFirst();

     else
        return null;
   } // retrieve


/* display all elements in the queue */   //It may not be needed
   public QueueInfo[] listQueue ()
   {
    QueueInfo[] retarray = new QueueInfo[q_list.size()];

      for (int i = 0; i < q_list.size(); i++) {
	      retarray[i] = (QueueInfo) q_list.get(i);
        }
       return retarray;

   }
   } //QueuedFiles



