package net.sourceforge.journeyftp.backend;
import net.sourceforge.journeyftp.adapter.*;
import java.io.*;



public class TransferOperator
{
	private	FTPBackend controller;
	private	ErrorManager errorHandler;
	
	public TransferOperator ( FTPBackend newController, ErrorManager newErrorHandler)
	{
		controller = newController;
		errorHandler = newErrorHandler;
	}
	
	
	boolean getFile (VirtualFile toGet, TransferAdapter toUse, ConnectionInfo myHost)
	{

	            	
                FileOutputStream fos = null;
                File file = new File(toGet.getDestinationDir() + File.separator + toGet.getName());

                if(file.exists())
                {
                    errorHandler.outputError( toGet.getName() + ": Already exists." );
                    return false;
                }
                else
                {
                    try
                    {
                    //    System.out.println("about to get rem file to local file " + System.getProperty("user.dir") + File.separator + toGet[i].getName());
                        fos = new FileOutputStream( file );
                        toUse.getFile( toGet.getResidentDir() + File.separator + toGet.getName(), fos, 0 );
                    }
                    catch ( FileNotFoundException fnfe )
                    {
                        errorHandler.outputError( toGet.getName() + ": File not readable." );
                        return false;
                    }
                    catch (ConnectionFailedException e)
                    {
                    	myHost.setConnected(false);
                    	return false;	
                    }


                    catch (TransferAdapterException e) // if this is a file exists exception we will need to prompt the user to overwrite/rename/resume the file
                    {
                        errorHandler.outputError( e.getMessage() );
                        return false;
                    }
                    /*catch (FileAlreadyExistsException e)
                    {
                        ask the user if he wants a rename/resume/overwrite, and if it's a rename, rename to what

                        if (choice.equals ("overwrite"))
                        {
                            VirtualFile[] delone = new VirtualFile[1];
                            delone[1] = toGet[i];
                            deleteLocFile(delone);
                            getFile(toGet[i]);
                        }
                        else if (choice.equals ("rename"))
                        {
                            renameLocFile(toGet[i], newfilename);
                            getFile(toGet[i]);
                        }
                        else if (choice.equals ( "resume" ))
                        {
                            fos = new FileOutputStream ( file )
                            backend.getFile(toGet[i].getName(), fos, toGet[i].getLength());
                        }

                    }    */

                  catch (IOException e)
                  {
                        errorHandler.outputError( "The following IO exception occurred: " + e.getMessage() );
                        return false;
                  }
	        }	
	        return true;
	}
	
	
	boolean putFile (VirtualFile toPut, TransferAdapter toUse, ConnectionInfo myHost)
	{		
		FileInputStream fis = null;

                File file = new File (toPut.getResidentDir() + File.separator + toPut.getName());
                if ( ! file.canRead() )
             	{
                    errorHandler.outputError( toPut.getName() + ": Unable to read file." );
                    return false;
	        }				
            try
            {
                fis = new FileInputStream( file );
                toUse.putFile( toPut.getDestinationDir() + File.separator  +toPut.getName(), fis, 0 );
            }
            catch ( FileNotFoundException fnfe )
            {
                errorHandler.outputError( toPut.getName() + ": File not found." );
            }
            catch (ConnectionFailedException cfe )
            {
	        errorHandler.outputError( "You are no longer connected." );
	        myHost.setConnected(false);
	        return false;
   	    }
   	
        /*catch (FileAlreadyExistsException e)
            {
                    ask the user if he wants a rename/resume/overwrite, and if it's a rename, rename to what

                    if (choice.equals ("overwrite"))
                    {
                        VirtualFile[] delone = new VirtualFile[1];
                        delone[1] = toPut[i];
                        deleteRemFile(delone);
                        putFile(toPut[i]);
                    }
                    else if (choice.equals ("rename"))
                    {
                        renameRemFile(toPut[i], newfilename);
                        putFile(toPut[i]);
                    }

                    else if (choice.equals ( "resume" ))
                    {
                        fis = new FileInputStream ( file )
                        backend.putFile(toPut[i].getName(), fis, toPut[i].getLength());
                    }

            }    */


        catch (TransferAdapterException e)
        {

		errorHandler.outputError( " Error: " + e.getMessage());
		return false;
        }
        return true;	
}



}