package net.sourceforge.journeyftp.gui;
import net.sourceforge.journeyftp.adapter.*;
import net.sourceforge.journeyftp.backend.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import java.lang.*;

public class Login extends JDialog{
    JComboBox transferMode, last10;
    static JTextField userPick, hostPick,workPick,sharePick;
    JPasswordField psswdPick;
    boolean connect = false;
    static ConnectionInfo passingHost;
    public Login(JFrame window, final FTPBackend backEnd) {
        super(window,"Login : ",true);
        Toolkit kit = getToolkit();
        Dimension wndSize = kit.getScreenSize();

        setBounds(wndSize.width/3,wndSize.height/3,wndSize.width/3,wndSize.height/3);

        GridBagLayout grid = new GridBagLayout();
        GridBagConstraints constraints = new GridBagConstraints();
        getContentPane().setLayout(grid);

        constraints.insets = new Insets(5,5,5,5);

        constraints.fill = constraints.HORIZONTAL;

        JLabel hostLabel = new JLabel();
        JLabel userLabel = new JLabel();
        JLabel psswdLabel = new JLabel();
        JLabel trnsfrLabel = new JLabel();
        JLabel workgroup = new JLabel();
        JLabel shareName = new JLabel();
        JLabel optional = new JLabel();

        constraints.gridx = 0;
        constraints.weightx = constraints.weighty = 10;
        constraints.fill = constraints.HORIZONTAL;
        constraints.insets = new Insets(5,5,5,5);

	String [] hosts = backEnd.getHostListStrings();
	String [] finalHosts = new String[hosts.length+1];
	for (int DYER=0; DYER<hosts.length; DYER++){
		finalHosts[DYER+1] = new String(hosts[DYER]);
		System.out.println(hosts[DYER]);
	}
	finalHosts[0] = "New";
        last10 = new JComboBox(finalHosts);
	constraints.gridwidth = 2;
	grid.setConstraints(last10,constraints);
	constraints.gridwidth = 1;

        hostLabel.setText("Host Name : ");
        userLabel.setText("User Name : ");
        psswdLabel.setText("Password : ");
        trnsfrLabel.setText("Transfer Mode : ");
        optional.setText("Optional WFS Arguments");
        workgroup.setText("WFS Workgroup : ");
        shareName.setText("WFS Share Name : ");
        grid.setConstraints(psswdLabel,constraints);
        grid.setConstraints(userLabel,constraints);
        grid.setConstraints(hostLabel,constraints);
        grid.setConstraints(trnsfrLabel,constraints);
        grid.setConstraints(workgroup,constraints);
        grid.setConstraints(shareName,constraints);
        constraints.gridwidth = 2;
        grid.setConstraints(optional,constraints);
        constraints.gridwidth = 1;

        hostPick = new JTextField("");
        userPick = new JTextField("");
        psswdPick = new JPasswordField("");
        workPick = new JTextField("");
        sharePick = new JTextField("");
        String[] modes = {"Automatic","FTP","Telnet","Windows File Sharing"};
        transferMode = new JComboBox(modes);
        transferMode.setSelectedItem("Automatic");
        constraints.gridx = 1;
        grid.setConstraints(psswdPick,constraints);
        grid.setConstraints(userPick,constraints);
        grid.setConstraints(hostPick,constraints);
        grid.setConstraints(transferMode,constraints);
        grid.setConstraints(sharePick,constraints);
        grid.setConstraints(workPick,constraints);
	getContentPane().add(last10);
        getContentPane().add(hostLabel);
        getContentPane().add(userLabel);
        getContentPane().add(psswdLabel);
        getContentPane().add(trnsfrLabel);
        getContentPane().add(hostPick);
        getContentPane().add(userPick);
        getContentPane().add(psswdPick);
        getContentPane().add(transferMode);

        getContentPane().add(optional);
        getContentPane().add(workgroup);
        getContentPane().add(shareName);
        getContentPane().add(workPick);
        getContentPane().add(sharePick);

        JButton OK = new JButton("OK");
        JButton cancel = new JButton("Cancel");
        constraints.gridx=0;
        grid.setConstraints(OK,constraints);
        constraints.gridx=1;
        grid.setConstraints(cancel,constraints);
        getContentPane().add(OK);
        getContentPane().add(cancel);

        OK.addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent e) {
					connect = false;
                            String connectionType = null;
                            passingHost = new ConnectionInfo();
 					if (last10.getSelectedIndex()==0) {
                            passingHost.setHost(hostPick.getText());
                            passingHost.setPassword(new String(psswdPick.getPassword()));
                            passingHost.setUsername(userPick.getText());
                            passingHost.setWorkgroup(workPick.getText());
                            passingHost.setShareName(sharePick.getText());
                            if (transferMode.getSelectedIndex()==0)
                                passingHost.setProtocol(new String("Automatic"));
                            else if (transferMode.getSelectedIndex()==1)
                                passingHost.setProtocol(new String("FTP"));
                            else if (transferMode.getSelectedIndex()==2)
                                 passingHost.setProtocol(new String("Telnet"));
                            else passingHost.setProtocol(new String("Windows File Sharing"));
					} else {
					passingHost = backEnd.getHostList()[last10.getSelectedIndex()-1];
					passingHost.setPassword(new String(psswdPick.getPassword()));
					}
                            connect = backEnd.doConnect(passingHost);
                            setVisible(false);
                        }
                        });
        cancel.addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent e) {
					connect = false;
                            setVisible(false);
                        }
                    });

	last10.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if (last10.getSelectedIndex()!=0) {
						passingHost = backEnd.getHostList()[last10.getSelectedIndex()-1];
						hostPick.setText(passingHost.getHost());
						userPick.setText(passingHost.getUsername());
						workPick.setText(passingHost.getWorkgroup());
						sharePick.setText(passingHost.getShareName());
						psswdPick.setText(passingHost.getPassword());
					}
				}
			});
    }

    boolean tryConnecting() {
        setVisible(true);
        while (isVisible());
        return connect;
    }
}
