package net.sourceforge.journeyftp.gui;
import net.sourceforge.journeyftp.adapter.*;
import net.sourceforge.journeyftp.backend.*;


import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;

public class QueueWnd extends JDialog{
	JList logWindow;
	static QueuedFile queue = new QueuedFile();
	JButton clear;
	
	public QueueWnd(final JFrame window, final MessageManager backEndBullShit, final JRadioButton noQueue, final FTPBackend back,
				final JButton refresh) {
		Toolkit kit = getToolkit();
		Dimension wndSize = kit.getScreenSize();

		setTitle("Queued Transfers : ");
		setBounds(1*wndSize.width/3,1*wndSize.height/3,wndSize.width/3,wndSize.height/3);
		Rectangle bounds = window.getBounds();
		setLocation(bounds.x+bounds.width,bounds.y);

		GridBagLayout grid = new GridBagLayout();
		GridBagConstraints constraints = new GridBagConstraints();
		getContentPane().setLayout(grid);
		
		constraints.weightx = constraints.weighty = 10;
		constraints.insets = new Insets(5,5,5,5);
		
		String [] logInfo = {};
		constraints.fill = constraints.BOTH;
		constraints.gridwidth=2;
		logWindow = new JList(logInfo);
		logWindow.setValueIsAdjusting(true);
		logWindow.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		JScrollPane logPane = new JScrollPane(logWindow);
		logPane.setMinimumSize(new Dimension(300,100));

		grid.setConstraints(logWindow,constraints);
		logWindow.setBorder(BorderFactory.createRaisedBevelBorder());
		getContentPane().add(logWindow);

		constraints.fill = constraints.HORIZONTAL;

		constraints.gridwidth=1;
		constraints.weighty=1;
		JButton begin = new JButton("Begin Transfers");
		constraints.gridx=0;
		grid.setConstraints(begin,constraints);
		getContentPane().add(begin);		
		JButton delete = new JButton("Delete");
		constraints.gridx=1;
		grid.setConstraints(delete,constraints);
		getContentPane().add(delete);		
		JButton moveBottom = new JButton("Move to Bottom");
		constraints.gridx=0;
		grid.setConstraints(moveBottom,constraints);
		getContentPane().add(moveBottom);		
		JButton moveTop = new JButton("Move to Top");
		constraints.gridx=1;
		grid.setConstraints(moveTop,constraints);
		getContentPane().add(moveTop);		
		JButton moveUp = new JButton("Move Up");
		constraints.gridx=0;
		grid.setConstraints(moveUp,constraints);
		getContentPane().add(moveUp);		
		JButton moveDown = new JButton("Move Down");
		constraints.gridx=1;
		grid.setConstraints(moveDown,constraints);
		getContentPane().add(moveDown);		

		constraints.gridx=0;		
		constraints.gridwidth = 2;
		clear = new JButton("Clear Queue");
		grid.setConstraints(clear,constraints);
		getContentPane().add(clear);
		
		clear.addActionListener(new ActionListener() {
						Object[] clearList = {};
						public void actionPerformed(ActionEvent e){
 							queue.clear();
							logWindow.setListData(clearList);
						}
					});
		
		begin.addActionListener(new ActionListener() {
						public void actionPerformed(ActionEvent e){
							QueueFtp starter = new QueueFtp(new TransferProgress(window,new JList(), back),backEndBullShit, back);
							for (int i=0; i<queue.listQueue().length; i++) {
								System.out.println("Queued File : "+queue.listQueue()[i].getName());
							}
							starter.startQueue(queue);
							clear.doClick();
							noQueue.doClick();
							refresh.doClick();
						}
					});
 

		moveTop.addActionListener(new ActionListener() {
						public void actionPerformed(ActionEvent e){
							queue.moveToTop(queue.listQueue()[logWindow.getSelectedIndex()]);
							String[] queueStrings = new String[queue.listQueue().length];
							for (int DYER = 0; DYER<queue.listQueue().length; DYER++)
								queueStrings[DYER] = queue.listQueue()[DYER].getName();
							logWindow.setListData(queueStrings);
						}
					});

		moveBottom.addActionListener(new ActionListener() {
						public void actionPerformed(ActionEvent e){
							queue.moveToBottom(queue.listQueue()[logWindow.getSelectedIndex()]);
							String[] queueStrings = new String[queue.listQueue().length];
							for (int DYER = 0; DYER<queue.listQueue().length; DYER++)
								queueStrings[DYER] = queue.listQueue()[DYER].getName();
							logWindow.setListData(queueStrings);
						}
					});

		moveDown.addActionListener(new ActionListener() {
						public void actionPerformed(ActionEvent e){
							queue.moveDown(queue.listQueue()[logWindow.getSelectedIndex()]);
							String[] queueStrings = new String[queue.listQueue().length];
							for (int DYER = 0; DYER<queue.listQueue().length; DYER++)
								queueStrings[DYER] = queue.listQueue()[DYER].getName();
							logWindow.setListData(queueStrings);
						}
			});

		moveUp.addActionListener(new ActionListener() {
						public void actionPerformed(ActionEvent e){
							queue.moveUp(queue.listQueue()[logWindow.getSelectedIndex()]);
							String[] queueStrings = new String[queue.listQueue().length];
							for (int DYER = 0; DYER<queue.listQueue().length; DYER++)
								queueStrings[DYER] = queue.listQueue()[DYER].getName();
							logWindow.setListData(queueStrings);
						}
			});

		delete.addActionListener(new ActionListener() {
						public void actionPerformed(ActionEvent e){
							queue.delete(queue.listQueue()[logWindow.getSelectedIndex()]);
							String[] queueStrings = new String[queue.listQueue().length];
							for (int DYER = 0; DYER<queue.listQueue().length; DYER++)
								queueStrings[DYER] = queue.listQueue()[DYER].getName();
							logWindow.setListData(queueStrings);
						}
			});
	}
}
