package net.sourceforge.journeyftp.gui;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import net.sourceforge.journeyftp.backend.*;

public class TransferProgress implements TransferObserver {
	JDialog progressWnd;
	JLabel totalLabel = new JLabel();
	JLabel currentLabel = new JLabel();
	long sizeOfCurrent=0, totalSoFar=0;
	JList list;
	JProgressBar currentBar, totalBar;
	String[] events = {};
        int amount=0;
	static boolean stopped=false;
	static JButton stop;
	FTPBackend theBack;
	
	public void batchInitiated(long totalbytes) {
		totalBar.setMaximum((int)totalbytes);
		totalBar.setValue(0);
		totalSoFar=0;
		System.out.println("batch initiated "+totalbytes);
	}

	public void transferInitiated(String source, String destination, long size, String filename){	
		currentBar.setMaximum((int)size);
		currentLabel.setText("From "+source+" to "+destination);
		sizeOfCurrent = size;
		progressWnd.setVisible(true);
		currentBar.setValue(0);
		System.out.println("transfer initiated "+size);
	}

	public void transferFinished(String status){ //status will be either the error which occurred or the transfer was successful
	}

	public void batchFinished() {
		progressWnd.setVisible(false);
	}

	public void dataTransferred(long bytes){
		amount = amount + (int)bytes;
		currentBar.setValue((int)amount);
		totalBar.setValue((int)(totalSoFar+=bytes));
		progressWnd.update(progressWnd.getGraphics());
	}

	public TransferProgress(JFrame calledFrom, JList logList, FTPBackend back) {

		theBack = back;
		progressWnd = new JDialog(calledFrom,"Transfer Progress",false);

		Toolkit kit = progressWnd.getToolkit();
		Dimension wndSize = kit.getScreenSize();
		progressWnd.setBounds(1*wndSize.width/3,1*wndSize.height/3,wndSize.width/3,wndSize.height/3);

		Container content = progressWnd.getContentPane();
		content.setLayout(new GridLayout(5,1,5,5));
		stop = new JButton("Pause");
		currentBar = new JProgressBar();
	 	currentBar.setMinimum(0);
		totalBar = new JProgressBar();
		totalBar.setMinimum(0);
		totalLabel.setText("Progress of all files being transferred");
		list = logList;
		content.add(totalLabel);
		content.add(totalBar);
		content.add(currentLabel);			
	 	content.add(currentBar);			
//		content.add(stop);
		stopped = false;

	        stop.addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent e) {
					System.out.println("PUSHED STOP");
					if (!stopped) {
						theBack.doTheStop();
						stopped = true;
						stop.setText("Resume");
					}else{
						theBack.doTheResume();
						stop.setText("Stop");
						stopped = false;
					}
				}
		});

	}
}
