package net.sourceforge.journeyftp.gui;
import net.sourceforge.journeyftp.adapter.*;
import net.sourceforge.journeyftp.backend.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.io.*;

public class mainWindow {
    static JFrame aWindow = new JFrame("Journey FTP");
    static StatusBar ourBar;
    static JList localList,remoteList;
    static boolean queueing = false;
    static JList logList = new JList();
    static GuiMessages messager = new GuiMessages(aWindow,logList);
    static FTPBackend backEnd = new FTPBackend(messager);
    static Login login = new Login(aWindow,backEnd);
    static JButton chdirRemote, chdirLocal, refresh = new JButton("Refresh"), upDirLocal, upDirRemote;
    static VirtualFile[] localFiles = {};
    static VirtualFile[] remoteFiles = {};
    static JRadioButton rbutton,lbutton = new JRadioButton("Single Transfer Mode",true);
    static QueueWnd queueWnd = new QueueWnd(aWindow, messager, lbutton, backEnd, refresh);
    static String[] localFileNames;
    static String[] remoteFileNames;
    static boolean connected = false;
    static JLabel locDir,remDir;
    static JMenuItem locRename,remRename,remMkdir,remDelete;

    public static void main(String[] args) {
	try {
		UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
	} catch (Exception e) {}
        JMenuBar menuBar = new JMenuBar();
        JMenuItem connectItem, disconnectItem, exitItem, defaultDirItem, contentsItem, aboutItem;
        JMenuItem locDelete,locMkdir;
        JCheckBoxMenuItem queueModeBox;
        Toolkit kit = aWindow.getToolkit();
        Dimension wndSize = kit.getScreenSize();

        aWindow.setBounds(wndSize.width/8,wndSize.height/8,3*wndSize.width/4,3*wndSize.height/4);

        GridBagLayout grid = new GridBagLayout();
        GridBagConstraints constraints = new GridBagConstraints();
        aWindow.getContentPane().setLayout(grid);

        constraints.insets = new Insets(5,5,5,5);

        constraints.fill = constraints.HORIZONTAL;

        aWindow.setTitle("Journey File Transfer System");
        aWindow.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);

        aWindow.setJMenuBar(menuBar);

        JMenu connectMenu = new JMenu("Connect");
        JMenu helpMenu = new JMenu("Help");
        JMenu locEditMenu = new JMenu("Local Edit");
        JMenu remEditMenu = new JMenu("Remote Edit");
        connectMenu.setMnemonic('C');
        helpMenu.setMnemonic('H');
        locEditMenu.setMnemonic('L');
        remEditMenu.setMnemonic('R');

        menuBar.add(connectMenu);
        menuBar.add(locEditMenu);
        menuBar.add(remEditMenu);
        menuBar.add(helpMenu);

        //items for the Connect menu
        connectItem = connectMenu.add("Connect");
        defaultDirItem = connectMenu.add("Set Current Dir to Default");
        connectMenu.addSeparator();
        exitItem = connectMenu.add("Exit");
        connectItem.setAccelerator(KeyStroke.getKeyStroke('C',Event.CTRL_MASK));
        defaultDirItem.setAccelerator(KeyStroke.getKeyStroke('F',Event.CTRL_MASK));
        exitItem.setAccelerator(KeyStroke.getKeyStroke('X',Event.CTRL_MASK));

        //items for the Help menu
        contentsItem = helpMenu.add("Contents");
        helpMenu.addSeparator();
        aboutItem = helpMenu.add("About Journey FTP");
        contentsItem.setAccelerator(KeyStroke.getKeyStroke('H',Event.CTRL_MASK));
        aboutItem.setAccelerator(KeyStroke.getKeyStroke('A',Event.CTRL_MASK));

        //items for Local Edit Menu
        locRename = locEditMenu.add("Rename");
        locMkdir = locEditMenu.add("Add Directory");
        locDelete = locEditMenu.add("Delete");
        locDelete.setAccelerator(KeyStroke.getKeyStroke('D',Event.CTRL_MASK));
        locRename.setAccelerator(KeyStroke.getKeyStroke('R',Event.CTRL_MASK));
        locMkdir.setAccelerator(KeyStroke.getKeyStroke('M',Event.CTRL_MASK));

        //items for Remote Edit Menu
        remRename = remEditMenu.add("Rename");
        remMkdir = remEditMenu.add("Add Directory");
        remDelete = remEditMenu.add("Delete");
        remDelete.setAccelerator(KeyStroke.getKeyStroke('T',Event.CTRL_MASK));
        remRename.setAccelerator(KeyStroke.getKeyStroke('N',Event.CTRL_MASK));
        remMkdir.setAccelerator(KeyStroke.getKeyStroke('K',Event.CTRL_MASK));

        JLabel local = new JLabel();
        constraints.gridx = 0;
        local.setText("Local System: ");
        grid.setConstraints(local,constraints);
        aWindow.getContentPane().add(local);

        constraints.gridx = 2;
        JLabel remote = new JLabel();
        remote.setText("Remote System: ");
        grid.setConstraints(remote,constraints);
        aWindow.getContentPane().add(remote);

        locDir = new JLabel();
	remDir = new JLabel();
        constraints.gridx = 0;
	if (backEnd.locPwd().length()<18)
	   	locDir.setText(backEnd.locPwd());
	else locDir.setText("..."+backEnd.locPwd().substring(backEnd.locPwd().length()-15,backEnd.locPwd().length()));
        grid.setConstraints(locDir,constraints);
        aWindow.getContentPane().add(locDir);

        constraints.gridx = 2;
	remDir.setText("Not Connected");
        grid.setConstraints(remDir,constraints);
        aWindow.getContentPane().add(remDir);

        constraints.weightx = 10; constraints.weighty = 14.0;
        constraints.fill = constraints.BOTH;
        Border edge = BorderFactory.createRaisedBevelBorder();

        //list box
        localFiles = backEnd.listLocFiles();
        localFileNames = new String[localFiles.length];
        remoteFileNames = new String[remoteFiles.length];
        for (int i=0; i<localFiles.length;i++)
            if (localFiles[i].isDirectory())
                localFileNames[i] = "["+localFiles[i].getName()+"]";
            else localFileNames[i] = localFiles[i].getName()+getSizeString(localFiles[i]);
        for (int i=0; i<remoteFiles.length;i++)
            if (remoteFiles[i].isDirectory())
                remoteFileNames[i] = "["+remoteFiles[i].getName()+"]";
            else remoteFileNames[i] = remoteFiles[i].getName()+getSizeString(remoteFiles[i]);
        constraints.gridy = 2;
        constraints.gridx = 0;
        constraints.fill = constraints.BOTH;
        constraints.gridheight = 4;
        localList = new JList(localFileNames);
        localList.setValueIsAdjusting(true);
        localList.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
        JScrollPane localPane = new JScrollPane(localList);
        localPane.setMinimumSize(new Dimension(300,100));

        grid.setConstraints(localPane,constraints);
        localPane.setBorder(edge);
        aWindow.getContentPane().add(localPane);

        constraints.gridx=2;
        remoteList = new JList(remoteFileNames);
        remoteList.setValueIsAdjusting(true);
        remoteList.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
        JScrollPane remotePane = new JScrollPane(remoteList);
        remotePane.setMinimumSize(new Dimension(300,100));

        grid.setConstraints(remotePane,constraints);
        remotePane.setBorder(edge);
        aWindow.getContentPane().add(remotePane);

        constraints.gridheight=1;
        constraints.gridx=1;
        constraints.fill = constraints.BOTH;
        constraints.weightx = 2;
        constraints.weighty = 4;
        JButton getButton = new JButton("<---");
        getButton.setBorder(edge);
        grid.setConstraints(getButton,constraints);
        aWindow.getContentPane().add(getButton);

        constraints.gridy = 3;
        JButton putButton = new JButton("--->");
        putButton.setBorder(edge);
        grid.setConstraints(putButton,constraints);
        aWindow.getContentPane().add(putButton);

        ButtonGroup queueMode = new ButtonGroup();
        constraints.weighty = 1;
        queueMode.add(rbutton = new JRadioButton("Queue Mode"));
        constraints.gridy = 4;
        grid.setConstraints(rbutton,constraints);
        aWindow.getContentPane().add(rbutton);
        queueMode.add(lbutton);
        constraints.gridy=5;
        grid.setConstraints(lbutton,constraints);
        aWindow.getContentPane().add(lbutton);

        constraints.gridx = 0;
        constraints.gridy = 7;
        chdirLocal = new JButton("Change Directory");
        grid.setConstraints(chdirLocal,constraints);
        aWindow.getContentPane().add(chdirLocal);

        constraints.gridheight = 1;
        constraints.gridx = 2;
        chdirRemote = new JButton("Change Directory");
        grid.setConstraints(chdirRemote,constraints);
        aWindow.getContentPane().add(chdirRemote);
        chdirLocal.setEnabled(false);
        chdirRemote.setEnabled(false);
	remRename.setEnabled(false);
	locRename.setEnabled(false);
	remDelete.setEnabled(false);
	remMkdir.setEnabled(false);

        constraints.gridx = 0;
        constraints.gridy = 6;
        upDirLocal = new JButton("Up a Directory");
        grid.setConstraints(upDirLocal,constraints);
        aWindow.getContentPane().add(upDirLocal);
        constraints.gridx = 2;
        upDirRemote = new JButton("Up a Directory");
        grid.setConstraints(upDirRemote,constraints);
        aWindow.getContentPane().add(upDirRemote);
        upDirRemote.setEnabled(false);

        constraints.gridx = 1;
        constraints.gridheight = 2;
        grid.setConstraints(refresh,constraints);
        aWindow.getContentPane().add(refresh);

        constraints.fill = constraints.HORIZONTAL;
        constraints.gridx = 0;
        constraints.gridy = 8;
        constraints.gridheight = 1;
        constraints.weighty = 1;
        JLabel logLabel = new JLabel();
        logLabel.setText("Transfer Information");
        grid.setConstraints(logLabel,constraints);
        aWindow.getContentPane().add(logLabel);

        constraints.fill = constraints.BOTH;
        constraints.gridx=0;
        constraints.gridwidth=3;
        constraints.gridy=9;
        constraints.weighty=10;
        logList.setValueIsAdjusting(true);
        logList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        logList.setEnabled(false);
        JScrollPane logPane = new JScrollPane(logList);
        logPane.setMinimumSize(new Dimension(300,100));

        grid.setConstraints(logPane,constraints);
        logList.setBorder(edge);
        aWindow.getContentPane().add(logPane);

        ourBar = new StatusBar();
        constraints.insets = new Insets(0,0,0,0);
        constraints.gridheight=1;
        constraints.fill=constraints.BOTH;
        constraints.gridy=10;
        constraints.weighty = 1;
        grid.setConstraints(ourBar,constraints);
        ourBar.setBorder(edge);
        aWindow.getContentPane().add(ourBar);

        //Event handling
        aWindow.addWindowListener(new WindowAdapter() {
                        public void windowClosing(WindowEvent e) {
                            aWindow.dispose();
                            if (connected) backEnd.doDisconnect();
					backEnd.quit();
                            System.exit(0);
                        }
                      });

        queueWnd.addWindowListener(new WindowAdapter() {
                        public void windowClosing(WindowEvent e) {
                            queueWnd.dispose();
                            queueing = false;
                            lbutton.doClick();
                        }
                      });

        getButton.addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent e) {
                            if (queueing) {
								String[] tempNames;
                                for (int j=0;j<remoteList.getSelectedIndices().length;j++)
                					queueWnd.queue.append(new QueueInfo(remoteFiles[remoteList.getSelectedIndices()[j]],
								backEnd.getConnectionInfo(),backEnd.locPwd(),backEnd.remPwd(),"get"));
                                tempNames = new String[queueWnd.queue.listQueue().length];
                                for (int Jack=0; Jack<queueWnd.queue.listQueue().length;Jack++)
                                    tempNames[Jack] =
                                    queueWnd.queue.listQueue()[Jack].getName();
                                queueWnd.logWindow.setListData(tempNames);
                            } else {
                                int length = remoteList.getSelectedIndices().length;
                                int [] indices = remoteList.getSelectedIndices();
                                VirtualFile[] filesToGet = new VirtualFile[length];
                                if (length!=0) {
                                for (int i=0;i<length; i++)
                                    filesToGet[i] =  new
                                        VirtualFile(remoteFiles[indices[i]]);
                                backEnd.getFile(filesToGet, new TransferProgress(aWindow,logList,backEnd));
                                localFiles = backEnd.listLocFiles();
                                localFileNames = new String[localFiles.length];
                                for (int DYER=0; DYER<localFiles.length; DYER++)
                                    if (localFiles[DYER].isDirectory())
                                        localFileNames[DYER] =
                                        "["+localFiles[DYER].getName()+"]";
                                    else localFileNames[DYER] = localFiles[DYER].getName()+getSizeString(localFiles[DYER]);
                                localList.setListData(localFileNames);
                                }
                            }
                        }
                        });

        putButton.addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent e) {
					if (connected) {
	                            if (queueing) {
								String[] tempNames;
   		                        for (int j=0;j<localList.getSelectedIndices().length;j++)
     		           					queueWnd.queue.append(new QueueInfo(localFiles[localList.getSelectedIndices()[j]],
										backEnd.getConnectionInfo(),backEnd.locPwd(),backEnd.remPwd(),"put"));
        	                        tempNames = new String[queueWnd.queue.listQueue().length];
          	                      for (int Jack=0; Jack<queueWnd.queue.listQueue().length;Jack++)
           	                         tempNames[Jack] =
            	                         queueWnd.queue.listQueue()[Jack].getName();
              		                  queueWnd.logWindow.setListData(tempNames);
                		            } else {
	                                 int length = localList.getSelectedIndices().length;
	                                 if (length != 0) {
	 	                                 int [] indices = localList.getSelectedIndices();
   		                                 VirtualFile[] filesToPut = new VirtualFile[length];
            			                     for (int i=0;i<length; i++)
               			  	    	           filesToPut[i] =  new
                  			    	                  VirtualFile(localFiles[indices[i]]);
                     				     remoteFiles = backEnd.listRemFiles();
                          			     remoteFileNames = new String[remoteFiles.length];
	                             		     for (int DYER=0; DYER<remoteFiles.length; DYER++)
		                                       if (remoteFiles[DYER].isDirectory())
    			                                    remoteFileNames[DYER] =
      			                                  "["+remoteFiles[DYER].getName()+"]";
         	 	                               else remoteFileNames[DYER] = remoteFiles[DYER].getName()+getSizeString(remoteFiles[DYER]);
	           		                     remoteList.setListData(remoteFileNames);
	             		                     backEnd.putFile(filesToPut, new TransferProgress(aWindow,logList,backEnd));
	       				  }
          				}
					}
                        }
                        });

        rbutton.addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent e) {
					if (connected) {
	                            queueWnd.setVisible(true);
 	                            queueing = true;
							messager.setQueueing(queueing);
					} else {
						JOptionPane.showMessageDialog(aWindow,"You are not connected to any remote machine!","Warning",0);
						lbutton.doClick(); 
					}
                        }
                        });

        lbutton.addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent e) {
                            queueWnd.setVisible(false);
                            queueing = false;
					messager.setQueueing(queueing);
                        }
                        });

        refresh.addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent e) {
                            localFiles = backEnd.listLocFiles();
                            localFileNames = new String[localFiles.length];
                            for (int DYER=0; DYER<localFiles.length; DYER++)
                                if (localFiles[DYER].isDirectory())
                                    localFileNames[DYER] =
                                    "["+localFiles[DYER].getName()+"]";
                                else localFileNames[DYER] = localFiles[DYER].getName()+getSizeString(localFiles[DYER]);
                            localList.setListData(localFileNames);
                            if (connected) {
                                remoteFiles = backEnd.listRemFiles();
                                remoteFileNames = new String[remoteFiles.length];
                                for (int JD=0; JD<remoteFiles.length; JD++)
                                    if (remoteFiles[JD].isDirectory())
                                        remoteFileNames[JD] =
                                        "["+remoteFiles[JD].getName()+"]";
                                    else remoteFileNames[JD] = remoteFiles[JD].getName()+getSizeString(remoteFiles[JD]);
                                remoteList.setListData(remoteFileNames);
                            }
                        }
                        });

        chdirLocal.addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent e) {
                            backEnd.changeLocDir(backEnd.listLocFiles()[localList.getSelectedIndices()[0]].getName());
                            localFiles = backEnd.listLocFiles();
                            localFileNames = new String[localFiles.length];
                            for (int DYER=0; DYER<localFiles.length; DYER++)
                                if (localFiles[DYER].isDirectory())
                                    localFileNames[DYER] =
                                    "["+localFiles[DYER].getName()+"]";
                                else localFileNames[DYER] = localFiles[DYER].getName()+getSizeString(localFiles[DYER]);
                            localList.setListData(localFileNames);
					String locDirName = backEnd.locPwd();
					if (locDirName.length()<18)
                            	locDir.setText(locDirName);
					else locDir.setText("..."+locDirName.substring(locDirName.length()-15,locDirName.length()));
                        }
                        });

        upDirLocal.addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent e) {
                            backEnd.changeLocDir("..");
                            localFiles = backEnd.listLocFiles();
                            localFileNames = new String[localFiles.length];
                            for (int DYER=0; DYER<localFiles.length; DYER++)
                                if (localFiles[DYER].isDirectory())
                                    localFileNames[DYER] =
                                    "["+localFiles[DYER].getName()+"]";
                                else localFileNames[DYER] = localFiles[DYER].getName()+getSizeString(localFiles[DYER]);
                            localList.setListData(localFileNames);
					String locDirName = backEnd.locPwd();
					if (locDirName.length()<18)
                            	locDir.setText(locDirName);
					else locDir.setText("..."+locDirName.substring(locDirName.length()-15,locDirName.length()));
                        }
                        });

        upDirRemote.addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent e) {
                            backEnd.changeRemDir("..");
                            remoteFiles = backEnd.listRemFiles();
                            remoteFileNames = new String[remoteFiles.length];
                            for (int DYER=0; DYER<remoteFiles.length; DYER++)
                                if (remoteFiles[DYER].isDirectory())
                                    remoteFileNames[DYER] =
                                    "["+remoteFiles[DYER].getName()+"]";
                                else remoteFileNames[DYER] = remoteFiles[DYER].getName()+getSizeString(remoteFiles[DYER]);
                            remoteList.setListData(remoteFileNames);
					String remDirName = backEnd.remPwd();
					if (remDirName.length()<18)
                            	remDir.setText(remDirName);
					else remDir.setText("..."+remDirName.substring(remDirName.length()-15,remDirName.length()));
                        }
                        });

        chdirRemote.addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent e) {
                            backEnd.changeRemDir(backEnd.listRemFiles()[remoteList.getSelectedIndices()[0]].getName());
                            remoteFiles = backEnd.listRemFiles();
                            remoteFileNames = new String[remoteFiles.length];
                            for (int DYER=0; DYER<remoteFiles.length; DYER++)
                                if (remoteFiles[DYER].isDirectory())
                                    remoteFileNames[DYER] =
                                    "["+remoteFiles[DYER].getName()+"]";
                                else remoteFileNames[DYER] = remoteFiles[DYER].getName()+getSizeString(remoteFiles[DYER]);
                            remoteList.setListData(remoteFileNames);
					String remDirName = backEnd.remPwd();
					if (remDirName.length()<18)
                            	remDir.setText(remDirName);
					else remDir.setText("..."+remDirName.substring(remDirName.length()-15,remDirName.length()));
                        }
                        });

        connectItem.addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent e) {
                            if (connected) backEnd.doDisconnect();
					remoteFiles = new VirtualFile[0];
					remoteFileNames = new String[0];
					remoteList.setListData(remoteFileNames);
					remDelete.setEnabled(false);
					remMkdir.setEnabled(false);
					upDirRemote.setEnabled(false);
					login = new Login(aWindow,backEnd);
					ourBar.setColorPane("Connected to Nobody");
                            if (connected = login.tryConnecting()) {
                                remoteFiles = backEnd.listRemFiles();
                                remoteFileNames = new String[remoteFiles.length];
                                for (int i=0;i<remoteFiles.length;i++)
                                    if (remoteFiles[i].isDirectory())
                                        remoteFileNames[i] = new
                                        String("["+remoteFiles[i].getName()+"]");
                                    else remoteFileNames[i] = remoteFiles[i].getName()+getSizeString(remoteFiles[i]);
                                remoteList.setListData(remoteFileNames);
						String remDirName = backEnd.remPwd();
						if (remDirName.length()<18)
  	                          	remDir.setText(remDirName);
						else remDir.setText("..."+remDirName.substring(remDirName.length()-15,remDirName.length()));
                                ourBar.setColorPane("Connected to "+Login.hostPick.getText());
                                upDirRemote.setEnabled(true);
						remDelete.setEnabled(true);
						remMkdir.setEnabled(true);
                            }
                        }
                        });

        exitItem.addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent e) {
                            aWindow.dispose();
                            if (connected) backEnd.doDisconnect();
                            connected =false;
					backEnd.quit();
                            System.exit(0);
                        }
                        });

        defaultDirItem.addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent e) {
                            try {
                                backEnd.setDefaultDir(backEnd.locPwd());
                            } catch (IOException ex) {
                                System.out.println("Set default dir exception!");
                            }
                        }
                        });

        contentsItem.addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent e) {

					EditPaneExample help = new EditPaneExample(backEnd.getHelpFileLoc());
					help.runHelp();
                        }
                        });

        aboutItem.addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent e) {
					Message about = new Message(aWindow);
					about.setVisible(true);
                        }
                        });

        remRename.addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent e) {
					String newName = JOptionPane.showInputDialog(aWindow,"Enter new file name : ");
                            backEnd.renameRemFile(remoteFiles[remoteList.getSelectedIndices()[0]],newName);
                            remoteFiles = backEnd.listRemFiles();
                            remoteFileNames = new String[remoteFiles.length];
                            for (int JD=0; JD<remoteFiles.length; JD++)
                                if (remoteFiles[JD].isDirectory())
                                    remoteFileNames[JD] =
                                    "["+remoteFiles[JD].getName()+"]";
                                else remoteFileNames[JD] = remoteFiles[JD].getName()+getSizeString(remoteFiles[JD]);
                            remoteList.setListData(remoteFileNames);
                        }
                        });

        remDelete.addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent e) {
                            VirtualFile[] toDelete = new VirtualFile[remoteList.getSelectedIndices().length];
                            for (int DYER=0;DYER<remoteList.getSelectedIndices().length;DYER++)
                                toDelete[DYER] = new VirtualFile(remoteFiles[remoteList.getSelectedIndices()[DYER]]);
                            backEnd.deleteRemFile(toDelete);
                            refresh.doClick();
                        }
                        });

        remMkdir.addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent e) {
					String newName = JOptionPane.showInputDialog(aWindow,"Enter name for new directory: ");
                            backEnd.makeRemDir(newName);
                            refresh.doClick();
                        }
                        });

        locRename.addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent e) {
					String newName = JOptionPane.showInputDialog(aWindow,"Enter new file name : ");
                            backEnd.renameLocFile(localFiles[localList.getSelectedIndices()[0]],newName);
                            localFiles = backEnd.listLocFiles();
                            localFileNames = new String[localFiles.length];
                            for (int JD=0; JD<localFiles.length; JD++)
                                if (localFiles[JD].isDirectory())
                                    localFileNames[JD] =
                                    "["+localFiles[JD].getName()+"]";
                                else localFileNames[JD] = localFiles[JD].getName()+getSizeString(localFiles[JD]);
                            localList.setListData(localFileNames);
                        }
                        });

        locDelete.addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent e) {
                            VirtualFile[] toDelete = new VirtualFile[localList.getSelectedIndices().length];
                            for (int DYER=0;DYER<localList.getSelectedIndices().length;DYER++)
                                toDelete[DYER] = new VirtualFile(localFiles[localList.getSelectedIndices()[DYER]]);
                            backEnd.deleteLocFile(toDelete);
                            refresh.doClick();
                        }
                        });

        locMkdir.addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent e) {
					String newName = JOptionPane.showInputDialog(aWindow,"Enter name for new directory: ");
                            backEnd.makeLocDir(newName);
                            refresh.doClick();
                        }
                        });
 
        localList.addListSelectionListener(new ListSelectionListener() {
                            public void valueChanged(ListSelectionEvent e) {
                                chdirLocal.setEnabled(false);
						locRename.setEnabled(false);
                                if (localList.getSelectedIndices().length==1) {
                                    if
                                    (localFiles[localList.getSelectedIndices()[0]].isDirectory())
       		                             { chdirLocal.setEnabled(true);	}
							locRename.setEnabled(true); 
						}
                            }
                           });
        remoteList.addListSelectionListener(new ListSelectionListener() {
                            public void valueChanged(ListSelectionEvent e) {
                                chdirRemote.setEnabled(false);
						remRename.setEnabled(false);
                                if (remoteList.getSelectedIndices().length==1) {
                                    if
                                    (remoteFiles[remoteList.getSelectedIndices()[0]].isDirectory())
                                            { chdirRemote.setEnabled(true);	}
							remRename.setEnabled(true);
						}
                            }
                           });

	remoteList.addMouseListener(new MouseAdapter() {
		public void mouseClicked(MouseEvent e) {
			if (e.getClickCount()==2) {
					int index = remoteList.locationToIndex(e.getPoint());
					if (index>remoteFiles.length-1||index<0) return;
					if (remoteFiles[index].isDirectory()) {
	                            backEnd.changeRemDir(remoteFiles[index].getName());
   	                            remoteFiles = backEnd.listRemFiles();
  	                            remoteFileNames = new String[remoteFiles.length];
   	                         for (int DYER=0; DYER<remoteFiles.length; DYER++)
    	                            if (remoteFiles[DYER].isDirectory())
     	                               remoteFileNames[DYER] =
      	                               "["+remoteFiles[DYER].getName()+"]";
       	                            else remoteFileNames[DYER] = remoteFiles[DYER].getName()+getSizeString(remoteFiles[DYER]);
        	                       remoteList.setListData(remoteFileNames);
					  	 String remDirName = backEnd.remPwd();
						 if (remDirName.length()<18)
  	                          	remDir.setText(remDirName);
						 else remDir.setText("..."+remDirName.substring(remDirName.length()-15,remDirName.length()));
					} else JOptionPane.showMessageDialog(null,"That is not a directory!","Error",0);
			}
		}
	}); 

	localList.addMouseListener(new MouseAdapter() {
		public void mouseClicked(MouseEvent e) {
			if (e.getClickCount()==2) {
					int index = localList.locationToIndex(e.getPoint());
					if (index>localFiles.length-1||index<0) return;
					if (localFiles[index].isDirectory()) {
	                            backEnd.changeLocDir(localFiles[index].getName());
   	                            localFiles = backEnd.listLocFiles();
  	                            localFileNames = new String[localFiles.length];
   	                         for (int DYER=0; DYER<localFiles.length; DYER++)
    	                            if (localFiles[DYER].isDirectory())
     	                               localFileNames[DYER] =
      	                               "["+localFiles[DYER].getName()+"]";
       	                            else localFileNames[DYER] = localFiles[DYER].getName()+getSizeString(localFiles[DYER]);
        	                       localList.setListData(localFileNames);
					  	 String locDirName = backEnd.locPwd();
						 if (locDirName.length()<18)
  	                          	locDir.setText(locDirName);
						 else locDir.setText("..."+locDirName.substring(locDirName.length()-15,locDirName.length()));
					} else JOptionPane.showMessageDialog(aWindow,"That is not a directory!","Error",0);
			}
		}
	}); 

        aWindow.setVisible(true);
    }

    public static String getSizeString(VirtualFile file) {
	long size = file.getSize();
	String sizeString = new String();
	if (size<1000) return (" ("+sizeString+size+"bytes)");
	if (size<1000000) return (" ("+sizeString+size/1000+"kb)");
	else return (" ("+sizeString+size/1000000+"Mb)");
    }
}

class StatusBar extends JPanel{
    public StatusBar() {
        setLayout(new FlowLayout(FlowLayout.LEFT,10,3));
        setBackground(Color.lightGray);
        setBorder(BorderFactory.createLineBorder(Color.darkGray));
        add(colorPane);
    }

    public void setColorPane(String label) {
        //add text to panel
        colorPane.setText(label);
    }

    private StatusPane colorPane = new StatusPane("Connected to Nobody");

    class StatusPane extends JLabel {
        public StatusPane(String text) {
            setBackground(Color.lightGray);
            setForeground(Color.black);
            setHorizontalAlignment(LEFT);
            setBorder(BorderFactory.createBevelBorder(BevelBorder.LOWERED));
            setPreferredSize(new Dimension(300,20));
            setText(text);
        }
    }
}
